SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utilities'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

!False methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each)
				ifTrue: [ container append: (anObject perform: each) ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 10:56'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:56'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MADescription
	instanceVariableNames: 'key label priority properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^true! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
add: aDescription
	self remove: aDescription.
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
append: anObject
	(anObject isKindOf: MADescription)
		ifTrue: [ self add: anObject ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ self addAll: anObject ] ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol
	^children detect: [ :each | aSymbol = each key ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol ifAbsent: aBlock
	^children detect: [ :each | aSymbol = each key ] ifNone: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/10/2005 10:52'!
defaultChildCollection
	^SortedCollection sortBlock: [ :a :b | a priority <= b priority ].! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:53'!
initialize
	super initialize.
	children := self defaultChildCollection.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/10/2005 10:53'!
postCopy
	super postCopy.
	children := self defaultChildCollection 
		addAll: (self children collect: [ :each | each copy ]);
		yourself.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:27'!
defaultDefault
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:17'!
defaultKey
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	^super defaultTitle allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionKey
	^MASymbol key: #key label: 'Key' priority: 100 default: self defaultKey.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionLabel
	^MAString key: #label label: 'Label' priority: 110 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 10:29'!
descriptionPriority
	^MANumber key: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionReadonly
	^MABoolean key: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionVisible
	^MABoolean key: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^false! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey
	^self key: aKey label: aKey asString.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString
	^self key: aKey label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString priority: aNumber
	^self new
		key: aKey;
		label: aString;
		priority: aNumber;
		readonly: self defaultReadonly;
		visible: self defaultVisible;
		yourself.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/9/2005 18:29'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isConcrete
		ifFalse: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 3/9/2005 18:04'!
= aDescription
	^self key = aDescription key.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 3/9/2005 18:04'!
hash
	^self key hash.! !

!MADescription methodsFor: 'initialize-release' stamp: 'lr 3/9/2005 17:58'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key
	^key! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key: anObject
	key := anObject! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label
	^label! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label: aString
	label := aString! !

!MADescription methodsFor: 'copying' stamp: 'lr 3/10/2005 10:54'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 3/10/2005 10:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' key: '; print: self key.
	aStream nextPutAll: ' label: '; print: self label.
	aStream nextPutAll: ' priority: '; print: self priority.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority
	^priority! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority: aNumber
	priority := aNumber! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
properties
	^properties! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey put: aValue
	self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly	
	^self 
		propertyAt: #readonly 
		ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible	
	^self 
		propertyAt: #visible 
		ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElement
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MABinary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinary class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:40'!
defaultDefault
	^ByteArray new.! !

!MABinary class methodsFor: 'testing' stamp: 'lr 3/10/2005 10:35'!
isConcrete
	^true! !

!MABinary methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:41'!
coerce: anObject 
	^anObject asByteArray.! !

MAElement subclass: #MADate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADate class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:40'!
defaultDefault
	^Date current.! !

!MADate class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MADate methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:41'!
coerce: anObject 
	^anObject asDate.! !

!MAElement class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 14:43'!
defaultDefault
	^nil! !

!MAElement class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:50'!
descriptionDefault
	^self isConcrete 
		ifTrue: [ self key: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber
	^(super key: aKey label: aString priority: aNumber)
		default: self defaultDefault;
		yourself.! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber default: aValue
	^(self key: aKey label: aString priority: aNumber)
		default: aValue;
		yourself.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 15:54'!
coerce: anObject
	"Convert anObject into a something the model is able to handle."

	^anObject! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:08'!
default
	^default! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:08'!
default: anObject
	default := anObject! !

!MAElement methodsFor: 'private' stamp: 'lr 3/10/2005 10:07'!
errorReadonly
	self error: 'This description enforces read only access.'.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:46'!
read: aModel
	"Read from aModel using the receiver as description."
	
	^(aModel readUsing: self)
		ifNil: [ self default ].! !

!MAElement methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
readSelector	
	^self key asSymbol.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:47'!
write: anObject to: aModel
	"Write to aModel using the receiver as description and anObject as value."

	self isReadonly 
		ifTrue: [ self errorReadonly ].
	^aModel 
		write: (self coerce: anObject)
		using: self.! !

!MAElement methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
writeSelector	
	^(self key copyWith: $:) 
		asSymbol.! !

MAElement subclass: #MANumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumber class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:40'!
defaultDefault
	^0! !

!MANumber class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MANumber methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:41'!
coerce: anObject 
	^anObject asNumber.! !

MAElement subclass: #MAOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAOptions subclass: #MABoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 22:44'!
defaultOptions
	^Array with: true with: false.! !

!MABoolean class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MABoolean methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:42'!
coerce: anObject 
	^#('true' 't' 'yes' 'y' 'on' '1') includes: anObject asString.! !

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 22:19'!
defaultLabelBlock
	^MAReceiverBlock selector: #asLabel.! !

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultOptions
	self subclassResponsibility! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:22'!
labelBlock
	^self 
		propertyAt: #labelBlock 
		ifAbsent: [ self class defaultLabelBlock ].! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:22'!
labelBlock: aBlock
	self propertyAt: #labelBlock put: aBlock.! !

!MAOptions methodsFor: 'private' stamp: 'lr 3/10/2005 11:48'!
options
	^self class defaultOptions.! !

MAOptions subclass: #MASelection
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASelection class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:49'!
defaultOptions
	^OrderedCollection new.! !

!MASelection class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MASelection methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:47'!
options
	options isNil
		ifTrue: [ options := super options ].
	^options.! !

!MASelection methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:47'!
options: aCollection
	options := aCollection! !

!MASelection methodsFor: 'copying' stamp: 'lr 3/10/2005 11:48'!
postCopy
	super postCopy.
	self options: self options copy.! !

MAElement subclass: #MAString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAString subclass: #MAPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAString class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:41'!
defaultDefault
	^String new.! !

!MAString class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MAString methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:42'!
coerce: anObject
	^anObject asString.! !

MAString subclass: #MASymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbol methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:43'!
coerce: anObject 
	^anObject asString asSymbol.! !

MAString subclass: #MAText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MATime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATime class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:41'!
defaultDefault
	^Time current.! !

!MATime class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:15'!
isConcrete
	^true! !

!MATime methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:43'!
coerce: anObject 
	^anObject asTime.! !

Object subclass: #MAMockModel
	instanceVariableNames: 'values description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:46'!
descriptionBinary
	^MADate key: #date label: 'Date'.! !

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:47'!
descriptionDate
	^MADate key: #date! !

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:46'!
descriptionTime
	^MATime key: #time! !

!MAMockModel methodsFor: 'private' stamp: 'lr 3/10/2005 22:54'!
buildDescription
	^self class description copy in: [ :container |
		MAElement allSubclassesDo: [ :class |
			class isConcrete ifTrue: [ 
				container add: (class key: class description label asLowercase asSymbol) ] ].
		container ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 14:57'!
description
	description isNil
		ifTrue: [ description := self buildDescription ].
	^description.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
readUsing: aDescription
	^self values 
		at: aDescription key 
		ifAbsent: [ nil ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 16:54'!
values
	values isNil
		ifTrue: [ values := Dictionary new ].
	^values.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
write: anObject using: aDescription
	self values 
		at: aDescription key
		put: anObject.! !

Object subclass: #MAReceiverBlock
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAReceiverBlock class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 22:17'!
selector: aSelector
	^self new
		selector: aSelector;
		yourself.! !

!MAReceiverBlock methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:16'!
selector	
	^selector! !

!MAReceiverBlock methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:16'!
selector: aSelector
	selector := aSelector! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:15'!
value
	self shouldNotImplement.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:17'!
value: aReceiver
	^aReceiver perform: self selector.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:17'!
value: aReceiver value: anObject
	^aReceiver perform: self selector with: anObject.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:18'!
value: aReceiver value: anObject value: anotherObject
	^aReceiver perform: self selector with: anObject with: anotherObject.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:59'!
defaultContainer
	"Return the default description container."
	
	^MAContainer
		key: #yourself
		label: self defaultTitle.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	"Return the title of this class to be used in the description."
	
	^self name asString.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:38'!
description
	^MACachedBuilder default buildFor: self.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:39'!
readUsing: aDescription
	^self perform: aDescription readSelector.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:48'!
write: anObject using: aDescription
	self perform: aDescription writeSelector with: anObject.! !

!True methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !

TestCase subclass: #MAAbstractTest
	instanceVariableNames: 'value description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractTest methodsFor: 'utilities' stamp: 'lr 3/10/2005 11:27'!
createDescription: aClass
	description := aClass key: #value.! !

!MAAbstractTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value
	^value! !

!MAAbstractTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value: anObject
	value := anObject! !

MAAbstractTest subclass: #MADispatchTest
	instanceVariableNames: 'reader writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADispatchTest methodsFor: 'despatching' stamp: 'lr 3/10/2005 11:30'!
readUsing: aDescription
	^reader value: aDescription.! !

!MADispatchTest methodsFor: 'despatching' stamp: 'lr 3/10/2005 11:30'!
write: anObject using: aDescription
	reader value: anObject value: aDescription.! !
